--- old/usr/src/uts/common/sys/cmn_err.h	Wed Oct 25 00:07:46 2017
+++ new/usr/src/uts/common/sys/cmn_err.h	Wed Oct 25 00:07:46 2017
@@ -29,6 +29,7 @@
  *
  * Copyright 2013 Nexenta Systems, Inc.  All rights reserved.
  * Copyright 2016 Joyent, Inc.
+ * Copyright 2017 RackTop Systems.
  */
 
 #ifndef _SYS_CMN_ERR_H
@@ -40,6 +41,10 @@
 
 #include <sys/dditypes.h>
 
+#if !defined(_ASM) && defined(_FAKE_KERNEL)
+#include <stdio.h>
+#endif
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -58,6 +63,15 @@
 extern void cmn_err(int, const char *, ...)
     __KPRINTFLIKE(2);
 
+extern void vcmn_err(int, const char *, __va_list)
+    __KVPRINTFLIKE(2);
+
+#ifndef _FAKE_KERNEL
+/*
+ * The following functions are either absent from libfakekernel
+ * or have different prototypes from the versions in libc.
+ */
+
 extern void vzcmn_err(zoneid_t, int, const char *, __va_list)
     __KVPRINTFLIKE(3);
 
@@ -67,9 +81,6 @@
 extern void vdev_err(dev_info_t *, int, const char *, __va_list)
     __KVPRINTFLIKE(3);
 
-extern void vcmn_err(int, const char *, __va_list)
-    __KVPRINTFLIKE(2);
-
 /*PRINTFLIKE3*/
 extern void zcmn_err(zoneid_t, int, const char *, ...)
     __KPRINTFLIKE(3);
@@ -106,6 +117,8 @@
 extern char *vsprintf(char *, const char *, __va_list)
     __KVPRINTFLIKE(2);
 
+#endif /* !_FAKE_KERNEL */
+
 /*PRINTFLIKE1*/
 extern void panic(const char *, ...)
     __KPRINTFLIKE(1) __NORETURN;
